package com.ruoyi.web.v3.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.web.v3.entity.HbRiskStrategyDictionaryEntity;
import com.ruoyi.web.v3.mapper.HbRiskStrategyDictionaryMapper;
import com.ruoyi.web.v3.model.request.HbRiskStrategyDictionaryPageReq;
import com.ruoyi.web.v3.service.IHbRiskStrategyDictionaryService;
import com.ruoyi.web.v3.utils.QueryWrapperBuildUtil;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.ObjectUtils;

import java.util.Arrays;

import static com.ruoyi.common.core.domain.AjaxResult.error;
import static com.ruoyi.common.core.domain.AjaxResult.success;

@Service
public class HbRiskStrategyDictionaryImpl extends ServiceImpl<HbRiskStrategyDictionaryMapper, HbRiskStrategyDictionaryEntity> implements IHbRiskStrategyDictionaryService {

    @Transactional
    @Override
    public AjaxResult add(HbRiskStrategyDictionaryEntity request) {
        //入参检测
        if(ObjectUtils.isEmpty(request.getRisk())) {
            return error("请输入【事故隐患】！");
        }
        if(ObjectUtils.isEmpty(request.getStrategy())) {
            return error("请输入【安全措施】！");
        }
        //防重检测，
        Integer count = lambdaQuery()
                .eq(HbRiskStrategyDictionaryEntity::getRisk, request.getRisk())
                .eq(HbRiskStrategyDictionaryEntity::getStrategy, request.getStrategy()).count();
        if (count != 0) {
            return error("请勿重复添加！");
        }
        return success("添加成功", baseMapper.insert(request));
    }

    @Override
    public AjaxResult edit(HbRiskStrategyDictionaryEntity request) {
        //数据格式校验
        if(ObjectUtils.isEmpty(request.getId())){
            return error("待更新数据未传入有效ID，请设置数据的唯一标识ID！");
        }
        //根据数据的id更新所有不为空的字段
        return updateById(request) ? success("修改成功！") : error("修改失败，请重试！");
    }

    @Override
    public AjaxResult delete(String ids) {
        String[] idList = ids.split(",");
        return success("删除成功", removeByIds(Arrays.asList(idList)));
    }

    @Override
    public AjaxResult page(HbRiskStrategyDictionaryPageReq request) {
        //将请求报文转为实体类
        HbRiskStrategyDictionaryEntity entity = BeanUtil.toBean(request, HbRiskStrategyDictionaryEntity.class);
        //构造查询条件（检索条件未定时，先按不为空的字段进行等值查询）
        QueryWrapper<HbRiskStrategyDictionaryEntity> wrapper = QueryWrapperBuildUtil.notNoneEqWrapperHelper(entity);
        //数据按id降序排列
        wrapper.lambda().orderByDesc(HbRiskStrategyDictionaryEntity::getId);
        return success(baseMapper.selectPage(request.toPage(), wrapper));
    }

    @Override
    public AjaxResult listAll() {
        return success(lambdaQuery().orderByDesc(HbRiskStrategyDictionaryEntity::getId).list());
    }
}
